/** \file arc4.c
	ARCFOUR Algorithm
*/

#include <avr/io.h>
#include <inttypes.h>
#include <stdio.h>
#include "arc4.h"

/**inverseaza 2 octeti
*/
void swap_byte(uint8_t *a, uint8_t *b)
 {
     register uint8_t swapByte; 
     
     swapByte = *a; 
     *a = *b;      
     *b = swapByte;
 }

/**initializare codare
*/
void initARC4(uint8_t * key,uint8_t len)
{
	uint8_t m[256],x,y;
	register uint8_t a,i,j,k;
	x = y = 0;
	for( i = 0; i < 255; i++ )
        m[i] = i;
	m[255] = 255;
	j = k = 0;

    for( i = 0; i < 255; i++ )
    {
        a = m[i];
        j = (uint8_t) ( j + a + key[k] );
        m[i] = m[j]; m[j] = a;
        if( ++k >= len ) k = 0;
    }
	a = m[255];
    j = (uint8_t) ( j + a + key[k] );
    m[255] = m[j]; 
	m[j] = a;
}

/**codeaza sirul de caractere s cu parola key
   */
void codareARC4(uint8_t*s,uint16_t len, uint8_t * key, uint8_t keylen) 
{
	uint8_t m[256],x,y;
	register uint8_t a,i,j,k;
	uint16_t t;

	//partea de initializare
	x = y = 0;
	for( i = 0; i < 255; i++ )
        m[i] = i;
	m[255] = 255;
	j = k = 0;

    for( i = 0; i < 255; i++ )
    {
        a = m[i];
        j = (uint8_t) ( j + a + key[k] );
        m[i] = m[j]; m[j] = a;
        if( ++k >= keylen ) k = 0;
    }
	a = m[255];
    j = (uint8_t) ( j + a + key[k] );
    m[255] = m[j]; 
	m[j] = a;
	
	//partea de codare	
    for( t = 0; t < len; t++ )
    {
        x = (uint8_t) ( x + 1 ); 
        y = (uint8_t) ( y + m[x] );
		swap_byte(&m[x],&m[y]);
		j = (uint8_t) ( m[x] + m[y] );
        s[t] ^= m[j];
    }
}
