/** \file uart.c
	Simple uart functionality
*/

#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
#include <avr/pgmspace.h>
#include <stdio.h>

#include "uart.h"


/** Init UART.
	Setup I/O ports and interrups for the serial link
*/
void 	uart_init( void )
{
	UBRRH = 0;
    UBRRL = 103;
    UCSRB = 0x18;
    UCSRC = _BV(URSEL) | _BV(UCSZ1) | _BV(UCSZ0);
}

/** Receive a character.
	Get a character from the communications line.
	Will block if no character is available.
	\return Received character
*/
int uart_getchar(FILE* f)
{
int c;
// TODO
	loop_until_bit_is_set(UCSRA, RXC);
	 c=UDR;
	 if(c=='\r') c='\n';
	 uart_putchar(c,NULL);
	 return c;
}

/** Send a character.
	Transmit a character on the communications line.
	\param data Character to send
	\return Copy of transmitted character.
*/
int uart_putchar(char c, FILE *unused)      
{
// TODO
	  if (c == '\n')
        uart_putchar('\r', unused);
      loop_until_bit_is_set(UCSRA, UDRE);
      UDR = c;
      return 0;

}
